itsProject/itsProject/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),

    #start url
    #path('user/', include('user.urls')),
    path('', include('user.urls')),
]

itsProject/user/urls.py
from django.conf.urls import url
from . import views
from django.urls import path

app_name = 'user'

urlpatterns = [
    path('', views.user, name='user'),

    # register
    path('register/', views.registerView, name='register'),
    path('registerAction/', views.registerAction, name='registerAction'),

    #login logout
    path('login/', views.loginView, name='login'),
    path('loginAction/', views.loginAction, name='loginAction'),
    path('logout/', views.logout, name='logout'),

    #wallet
    path('wallet/', views.walletView, name='walletView'),
    path('wallet/pk', views.walletPKView, name='walletPKView'),
    path('wallet/changePassword', views.changeWalletPassword, name='changeWalletPassword'),

    ]

itsProject/user/models.py
import json

from django.db import models
from web3 import Web3, HTTPProvider, Account
from itsProject.settings import URL_INFURA as urlInfura


# Create your models here.
class User(models.Model):
    email = models.CharField(max_length=255)
    password = models.CharField(max_length=255)
    status = models.IntegerField(default=0)
    def __str__(self):
        return self.email


class Wallet(models.Model):
    address = models.CharField(max_length=255, default="")
    keystore = models.TextField(default="")
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    locked = models.BooleanField(default=False)

    def __str__(self):
        return self.address

    #creates wallet, sets address and keystore
    def newWallet(self, password):
        if(self.address == "" and self.keystore == ""):
            web3 = Web3(HTTPProvider(urlInfura))
            acc = web3.eth.account.create()
            ethAddress = acc.address
            keystore = Account.encrypt(acc.privateKey, password)
            #ethKey = web3.toHex(acc.privateKey)
            self.address = ethAddress
            self.keystore = str(keystore)

    #gets private key from keystore and password
    def unlockWallet(self, password):
        web3 = Web3(HTTPProvider(urlInfura))
        keystoreDict = eval(self.keystore)
        try:
            privateKey = Account.decrypt(keystoreDict, password)
        except:
            return ""
        return web3.toHex(privateKey)

    #generates new keystore with new password and pk
    def changeWalletPassword(self, oldPassword, newPassword):
        web3 = Web3(HTTPProvider(urlInfura))
        keystoreDict = eval(self.keystore)
        privateKey = Account.decrypt(keystoreDict, oldPassword)
        keystore = Account.encrypt(privateKey, newPassword)
        self.keystore = str(keystore)
        self.save()

    #returns current eth balance of address
    def getBalance(self,):
        web3 = Web3(HTTPProvider(urlInfura))
        balance = web3.eth.getBalance(str(self.address))
        return balance

itsProject/user/views.py
from django.http import HttpResponse
from django.shortcuts import render, redirect, get_object_or_404
from user.decorators import check_user_login
from user.userLogic import registerFunction, loginFunction
from user.models import User, Wallet
from itsProject.settings import startUrl


# Create your views here.

@check_user_login
def user(request):

    userId = request.session['userId']
    user = get_object_or_404(User, id=userId)
    wallet = get_object_or_404(Wallet, user=user)
    context = {
        'user': user,
        'wallet': wallet,
    }

    return render(request, "user/userProfile.html", context)


#register template
def registerView(request):
    return render(request, "user/register.html", {})


#gets POST data, and calls registerFunction
#on bad call redirects back
#success: to login
def registerAction(request):

    email = request.POST['email']
    password = request.POST['password']

    status = registerFunction(email, password)

    if status == 1:
        return redirect( startUrl + "login/")

    return redirect(startUrl + "register/")


#login template
def loginView(request):
    return render(request, "user/login.html", {})


#gets POST data, and calls loginFunction
#on bad call redirects back
#success: to homepage
def loginAction(request):
    if 'userId' in request.session:
        return redirect(startUrl)

    email = request.POST['email']
    password = request.POST['password']

    status = loginFunction(email, password)
    if status > 0:
        request.session['userId'] = str(status)
        return redirect(startUrl)

    return redirect(startUrl + "login/")

#delete session
def logout(request):
    del request.session['userId']
    return redirect(startUrl)


#wallet page view
def walletView(request):

    userId = request.session['userId']
    user = get_object_or_404(User, id=userId)
    wallet = get_object_or_404(Wallet, user=user)

    balance = wallet.getBalance()

    context = {
        'user': user,
        'wallet': wallet,
        'balance': balance,
    }

    return render(request, "wallet/wallet.html", context)


#PRIVATE KEY page, wallet/pk.html
def walletPKView(request):

    password = request.POST['PKpassword']
    userId = request.session['userId']
    user = get_object_or_404(User, id=userId)
    wallet = get_object_or_404(Wallet, user=user)

    pk = wallet.unlockWallet(password)

    context = {
        'pk': pk,
    }

    return render(request, "wallet/pk.html", context)


#tries to change wallet password, not account pass
def changeWalletPassword(request):

    oldPassword = request.POST['oldPassword']
    newPassword = request.POST['newPassword']

    userId = request.session['userId']
    user = get_object_or_404(User, id=userId)
    wallet = get_object_or_404(Wallet, user=user)

    try:
        wallet.changeWalletPassword(oldPassword,newPassword)
    except:
        return HttpResponse("error")

    return redirect(startUrl + "wallet/")

itsProject/user/templates/user/login.html
<!DOCTYPE html>
<html lang="en">
<head>

    <style>
#main {
  border:black solid 1px; width:500px; margin:0 auto; text-align:center;
  padding: 15px;
}
</style>
    <meta charset="UTF-8">
    <title>Login</title>
</head>
<body>

<div id="main">

    <form action="{% url 'user:loginAction' %}" method="post">
        {% csrf_token %}
        <input type="text" id="email" name="email"/>
        <br/>
        <input type="password" id="password" name="password"/>
        <br/>
        <input type="submit" value="Login"/>

    </form>


</div>
</body>
</html>

itsProject/user/templates/user/register.html
<!DOCTYPE html>
<html lang="en">
<head>


    <style>
#main {
  border:black solid 1px; width:500px; margin:0 auto; text-align:center;
  padding: 15px;
}
</style>

    <meta charset="UTF-8">
    <title>Register page</title>

</head>
<body>


<div id="main">

    <form action="{% url 'user:registerAction' %}" method="post">
        {% csrf_token %}
        <input type="text" id="email" name="email"/>
        <br/>
        <input type="password" id="password" name="password"/>
        <br/>
        <input type="submit" value="Register"/>

    </form>
<br/><br/>

    <a href="{% url 'user:login' %}">Login</a>

</div>

</body>
</html>

itsProject/user/templates/user/userProfile.html
<!DOCTYPE html>
<html lang="en">
<head>
     <style>
#main {
  border:black solid 1px; width:500px; margin:0 auto; text-align:center;
  padding: 15px;
}
</style>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>

<a href="{% url 'user:walletView' %}">wallet</a>

<div id="main">

    profile
    <br/>
    <br/>
    <br/>
    username/email:<br/>
    {{ user.email }}
    <br/><br/>


    <br/>
    address:<br/>
    {{ wallet.address }}
    <br/><br/>

    <br/><br/>
    <br/><br/>

    <a href="{% url 'user:logout' %}">Logout</a>

</div>

</body>
</html>

itsProject/user/templates/wallet/pk.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Wallet</title>
</head>
<body>

<br/>

<a href="{% url 'user:walletView' %}">back</a>

<br/>
<br/>

{{ pk }}

</body>
</html>

itsProject/user/templates/wallet/wallet.html
<!DOCTYPE html>
<html lang="en">
<head>

         <style>
.main {
  border:black solid 1px; width:500px; margin:0 auto; text-align:center;
  padding: 15px;
}
</style>

    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>

<a href="{% url 'user:user' %}">profile</a>

<div class="main">

    <br/>
    address:
    <br/>
    {{ wallet.address }}
    <br/><br/>
    balance:
    {{ balance }}


</div>

<div class="main">
    wallet

    <div>Click  to save your Private Key. <br>In case that you do not save your private key and you forgot your password your funds will be lost forever. <br>Because of security reasons we do not save your private key and we cannot recover your private key and funds. </div>
<div >
        <div >
            <h3 >View Private Key</h3>
            <div style="font-size: 14px; color: red;">We only store the keystore file of your wallet
                which needs to be combined with your personal password to unlock your wallet. In case that you did not
                save your private key after registering and you forgot your password your funds will be lost forever.
                Because of security reasons we do not save your private key and we cannot recover your private key and funds.
                <br>You can still export your private key with your password.</div>
            <div>Enter Password:</div>

            <form action="{% url 'user:walletPKView' %}" method="post">
                {% csrf_token %}
                <div>
                    <div>
                        <input type="password" name="PKpassword" id="PKpassword" minlength="6">
                    </div>
                    <div  style="max-width: 170px;">
                        <input type="submit" value="Show"/>
                    </div>
                    <!--div class="col-2">
                        <input type="button" value="Export as PDF" class="buttonGreen_small mrgB-0 animation" onclick="onClickGetPKPDFCheck()" />
                    </div-->
                </div>
            </form>


                <div style="display: none" id="privateKeyIfSuccessful">
                    <div>
                        <div class="passchangeText"> Your private key:</div>
                        <div style="font-weight: 700" id="privateKeyString"></div>
                        <div>IMPORTANT!!! <br> Do not share it with anybody. This private key allows you to access to your funds.</div>

                    </div>
                </div>

            </div>
        </div>
</div>


<div class="main">

    change password <i style="font-size: 14px; color: red;">(!!this does not change your acoout password!!)</i>

    <br/>
    ( generates new keysore)

    <form action="{% url 'user:changeWalletPassword' %}" method="post">
        {% csrf_token %}
<br/>
<br/>
        old password:<br/>
    <input type="password" id="oldPassword" name="oldPassword"><br/>
        new password:<br/>
    <input type="password" id="newPassword" name="newPassword"><br/>
    <input type="submit" value="Change Password"><br/>

    </form>

    <br/>



    <br/>
    <br/>

</div>

</body>
</html>